% BLAT01_01.m
t=trfopen('BLAT01RunAtoG1.trf');
s=trfload(t);
strkimg=trfwild(s,[],'Tracker.trkcamera.fpaImage');
spupfld=trfwild(s,[],'Telescope_.sfs.fld');
stbd=trfwild(s,[],'Target.targetboard.integrated_intensity');
strkfld=trfwild(s,[],'Tracker.sfs.fld');
sdm=trfwild(s,[],'DM.measuredActuatorPositions');
p=tmxparams(s.r);
xfld=opdc(p.Dap/p.propdxy,p.propdxy);
xtrkimg=opdc(p.trk_nxy,p.trk_dxy);
xtbd=opdc(p.tbd_nxy,p.tbd_dxy);
load c:/Program Files/mza/wavetrain/2007B/predata/fdf.mat xact yact actype
imas=find(actype>0);
[dm,xa,ya]=actmap(sdm.r.v.d(:,1),xact(imas),yact(imas));
figure
set(gcf,'position',[700,253,475,682]);
for ii=1:length(strkimg.r.v.t)
   subplot(3,2,1);
   imagesc(xfld,xfld,reshape(abs(spupfld.r.v.d(:,ii)).^2,40,40));
   title('Uncomp. Amp.');
   axis image;
   subplot(3,2,2);
   imagesc(xfld,xfld,reshape(angle(spupfld.r.v.d(:,ii)),40,40));
   title('Uncomp. Phase');
   axis image
   subplot(3,2,3);
   [dm,xa,ya]=actmap(-sdm.r.v.d(:,ii),xact(imas),yact(imas));
   imagesc(xa,ya,dm);
   title('DM Figure');
   axis image
   subplot(3,2,4);
   imagesc(xfld,xfld,reshape(angle(strkfld.r.v.d(:,ii)),40,40));
   title('Comp. Phase');
   axis image
   subplot(3,2,5);
   imagesc(xtrkimg,xtrkimg,reshape(strkimg.r.v.d(:,ii),128,128));
   title('Track Image');
   axis image
   subplot(3,2,6);
   imagesc(xtbd,xtbd,reshape(stbd.r.v.d(:,ii),128,128));
   axis image
   title('Projection');
   xlabel(['time = ',num2str(strkimg.r.v.t(ii),'%6.4f')]);
   drawnow;
   fprintf(1,'Hit any key to go on.\n');
   pause;
end;
figure;
set(gcf, 'position', [360,254,560,680]);
subplot(4,1,1);
w=trfwild(s,[],'Target.targetboardproc.maxIntensity');
plot(w.r.v.t,w.r.v.d,'bo-');
hold on;
w=trfwild(s,[],'Target.targetboardproc.onAxisIntensity');
plot(w.r.v.t,w.r.v.d,'rd-');
legend('Peak Intensity', 'On-axis Intensity', 0);
set(gca,'xlim',[min(w.r.v.t(:)),max(w.r.v.t)]);
tlim=get(gca,'xlim');
subplot(4,1,2);
w=trfwild(s,[],'AtoG.Target.targetboardproc.xavg');
imagesc(w.r.v.t,p.tbd_dxy*[-size(w.r.v.d,2)/2:-size(w.r.v.d,2)/2+size(w.r.v.d,2)-1],w.r.v.d);
title('X Average');
set(gca,'xlim',tlim);
subplot(4,1,3);
w=trfwild(s,[],'AtoG.Target.targetboardproc.yavg');
imagesc(w.r.v.t,p.tbd_dxy*[-size(w.r.v.d,2)/2:-size(w.r.v.d,2)/2+size(w.r.v.d,2)-1],w.r.v.d);
title('Y Average');
set(gca,'xlim',tlim);
subplot(4,1,4);
w=trfwild(s,[],'AtoG.Target.targetboardproc.pib');
imagesc(w.r.v.t,p.tbd_dxy*[0:size(w.r.v.d,2)],w.r.v.d);
title('Power in the Bucket');
set(gca,'xlim',tlim);
xlabel('Time (sec)');
