// tempus 2000.11g

//
// tempus, version 2000.11g, (c) Copyright 1995-2001, MZA Associates Corporation
// Generated on: Tue Mar 04 11:04:22 MST 2003
//


#include "tempus.h"
#include "Recorders.h"
#include "FileSys.h"

#include "BLAT01.h"

#ifndef NO_TEMPUS_SMF_MONITOR
   #include "TempusStatusSMF.h"
#endif

main(int argc, char* argv[])
{
   int ___ierr;
   char *___outfile="BLAT01RunAtoG.trf";

   ParamSet psAtoG;
   double  stopTime = 0.01;
   int  irand = 0;
   int  iatm = 0;
   int  iturb = 4;
   int  icontrol = 2;
   int  itraj = 1;
   float  htarget = 1231.0;
   float  altitude = 1524.0;
   float  hplatform = htarget+altitude;
   float  range0 = 20000.0;
   int  atmprofile0[2] = {3,1};
   Array<int>  atmprofile0_array(2);
   for(int mli_atmprofile0_0 = 0; mli_atmprofile0_0 < 2; mli_atmprofile0_0++)
      atmprofile0_array(mli_atmprofile0_0) = atmprofile0[mli_atmprofile0_0];

   int  atmprofile = atmprofile0[iatm];
   int  nscreens0[5] = {1,20,20,20,20};
   Array<int>  nscreens0_array(5);
   for(int mli_nscreens0_0 = 0; mli_nscreens0_0 < 5; mli_nscreens0_0++)
      nscreens0_array(mli_nscreens0_0) = nscreens0[mli_nscreens0_0];

   int  nscreens = nscreens0[iturb];
   float  turbfactor0[5] = {0.0,1.0,2.0,3.0,4.0};
   Array<float>  turbfactor0_array(5);
   for(int mli_turbfactor0_0 = 0; mli_turbfactor0_0 < 5; mli_turbfactor0_0++)
      turbfactor0_array(mli_turbfactor0_0) = turbfactor0[mli_turbfactor0_0];

   float  turbfactor = turbfactor0[iturb];
   float  vplaty0[3] = {0.0,50.0,100.0};
   Array<float>  vplaty0_array(3);
   for(int mli_vplaty0_0 = 0; mli_vplaty0_0 < 3; mli_vplaty0_0++)
      vplaty0_array(mli_vplaty0_0) = vplaty0[mli_vplaty0_0];

   TasatDMModel*  tdm = new TasatDMModel("c:/mza/wavetrain/predata/fdf.mat",TDMALL);
   char   ___tdmStr[128];
   sprintf(___tdmStr,"(TasatDMModel*)  TasatDMModel(\"c:/mza/wavetrain/predata/fdf.mat\",TDMALL)\n\0");
   float  hel_wavelength0 = 1.315e-06;
   float  Dap0 = 0.4;
   float  trk_gain0[3] = {0.0,1.0,1.0};
   Array<float>  trk_gain0_array(3);
   for(int mli_trk_gain0_0 = 0; mli_trk_gain0_0 < 3; mli_trk_gain0_0++)
      trk_gain0_array(mli_trk_gain0_0) = trk_gain0[mli_trk_gain0_0];

   float  AO_gain0[3] = {0.0,0.0,1.0};
   Array<float>  AO_gain0_array(3);
   for(int mli_AO_gain0_0 = 0; mli_AO_gain0_0 < 3; mli_AO_gain0_0++)
      AO_gain0_array(mli_AO_gain0_0) = AO_gain0[mli_AO_gain0_0];

   float  range = range0;
   float  tel_focus_range = range0;
   AcsAtmSpec  AtmSpec = AcsAtmSpec(atmprofile,hel_wavelength0,nscreens,turbfactor,hplatform,htarget,range);
   char   ___AtmSpecStr[179];
   sprintf(___AtmSpecStr,"(AcsAtmSpec)  AcsAtmSpec(atmprofile,hel_wavelength0,nscreens,turbfactor,hplatform,htarget,range)\n\0");
   int  AtmSeed = seedSequence(-123456789,irand);
   float  tmax = stopTime;
   Vector<float>  vplat = TwoVecF(0.0,vplaty0[itraj]);
   Vector<float>  vtarg = TwoVecF(0.0,0.0);
   Vector<float>  vwind = ZeroVecF(2);
   DMModel&  dmModel = *tdm;
   char   ___dmModelStr[21];
   sprintf(___dmModelStr,"(DMModel&)  *tdm\n\0");
   float  Dap = Dap0;
   float  hel_wavelength = hel_wavelength0;
   float  beacon_wavelength = hel_wavelength0;
   float  img_wavelength = hel_wavelength0+0.05e-06;
   float  beacon_x = 0.0;
   float  beacon_y = 0.0;
   int  propnxy = 256;
   float  propdxy = 0.01;
   int  tbd_nxy = 128;
   float  tbd_dxy = 0.025/5;
   double  control_interval = 1.0/2500.0;
   int  trk_nxy = 128;
   float  trk_dxy = 0.1*hel_wavelength/Dap0;
   float  trk_gain = trk_gain0[icontrol];
   float  bsm_timeConstant = 1.0e-06;
   float  AO_gain = AO_gain0[icontrol];
   float  dm_timeConstant = 1.0e-06;
   float  wfs_ifov = 0.35*hel_wavelength0/0.025;
   bool  img_on = false;
   int  img_nxy = 128;
   float  img_dxy = 0.2*hel_wavelength/Dap0;
   Vector<float>  img_x = VecF(9,0.0,0.0,0.0,0.0,0.0,-0.2,-0.1,0.1,0.2);
   Vector<float>  img_y = VecF(9,-0.2,-0.1,0.0,0.1,0.2,0.0,0.0,0.0,0.0);
   writeParam(psAtoG, "stopTime", DOUBLE, &stopTime);
   char *___trfname;
   int ___totalRuns, ___currentRun;
   int ___newDataFile = 0;
   ___totalRuns = 1;
   ___currentRun = 1;

#ifndef NO_TEMPUS_SMF_MONITOR
   char *___smfname;
   parseName(argc, argv, ___outfile, &___smfname, &___trfname, stopTime);
   TempusStatusSMFWriter ___smfWriter(___smfname, ___trfname, "",___totalRuns);
   setCurrentSMF(&___smfWriter);
#else
   char *___tmpbuf;
   parseName(argc, argv, ___outfile, &___tmpbuf, stopTime);
   delete [] ___tmpbuf;
#endif

   Universe uAtoG("uAtoG");
   Trace ___trace("runset rAtoG:");  ___trace.newline();

#ifndef NO_TEMPUS_SMF_MONITOR
   ___smfWriter.startNewRun(___currentRun, stopTime);
#endif

   BLAT01 AtoG(NULL, "AtoG",
                range,
                tel_focus_range,
                AtmSpec,
                AtmSeed,
                tmax,
                vplat,
                vtarg,
                vwind,
                dmModel,
                Dap,
                hel_wavelength,
                beacon_wavelength,
                img_wavelength,
                beacon_x,
                beacon_y,
                propnxy,
                propdxy,
                tbd_nxy,
                tbd_dxy,
                control_interval,
                trk_nxy,
                trk_dxy,
                trk_gain,
                bsm_timeConstant,
                AO_gain,
                dm_timeConstant,
                wfs_ifov,
                img_on,
                img_nxy,
                img_dxy,
                img_x,
                img_y);

   writeParam(psAtoG, "stopTime", DOUBLE, &stopTime);
   writeParam(psAtoG, "irand", INT, &irand);
   writeParam(psAtoG, "iatm", INT, &iatm);
   writeParam(psAtoG, "iturb", INT, &iturb);
   writeParam(psAtoG, "icontrol", INT, &icontrol);
   writeParam(psAtoG, "itraj", INT, &itraj);
   writeParam(psAtoG, "htarget", FLOAT, &htarget);
   writeParam(psAtoG, "altitude", FLOAT, &altitude);
   writeParam(psAtoG, "hplatform", FLOAT, &hplatform);
   writeParam(psAtoG, "range0", FLOAT, &range0);
   writeParam(psAtoG, "atmprofile0_array", ARRAY_INT, &atmprofile0_array);
   writeParam(psAtoG, "atmprofile", INT, &atmprofile);
   writeParam(psAtoG, "nscreens0_array", ARRAY_INT, &nscreens0_array);
   writeParam(psAtoG, "nscreens", INT, &nscreens);
   writeParam(psAtoG, "turbfactor0_array", ARRAY_FLOAT, &turbfactor0_array);
   writeParam(psAtoG, "turbfactor", FLOAT, &turbfactor);
   writeParam(psAtoG, "vplaty0_array", ARRAY_FLOAT, &vplaty0_array);
   writeParam(psAtoG, "tdm", OTHER_TYPE, ___tdmStr);
   writeParam(psAtoG, "hel_wavelength0", FLOAT, &hel_wavelength0);
   writeParam(psAtoG, "Dap0", FLOAT, &Dap0);
   writeParam(psAtoG, "trk_gain0_array", ARRAY_FLOAT, &trk_gain0_array);
   writeParam(psAtoG, "AO_gain0_array", ARRAY_FLOAT, &AO_gain0_array);
   writeParam(psAtoG, "range", FLOAT, &range);
   writeParam(psAtoG, "tel_focus_range", FLOAT, &tel_focus_range);
   writeParam(psAtoG, "AtmSpec", OTHER_TYPE, ___AtmSpecStr);
   writeParam(psAtoG, "AtmSeed", INT, &AtmSeed);
   writeParam(psAtoG, "tmax", FLOAT, &tmax);
   writeParam(psAtoG, "vplat", VECTOR_FLOAT, &vplat);
   writeParam(psAtoG, "vtarg", VECTOR_FLOAT, &vtarg);
   writeParam(psAtoG, "vwind", VECTOR_FLOAT, &vwind);
   writeParam(psAtoG, "dmModel", OTHER_TYPE, ___dmModelStr);
   writeParam(psAtoG, "Dap", FLOAT, &Dap);
   writeParam(psAtoG, "hel_wavelength", FLOAT, &hel_wavelength);
   writeParam(psAtoG, "beacon_wavelength", FLOAT, &beacon_wavelength);
   writeParam(psAtoG, "img_wavelength", FLOAT, &img_wavelength);
   writeParam(psAtoG, "beacon_x", FLOAT, &beacon_x);
   writeParam(psAtoG, "beacon_y", FLOAT, &beacon_y);
   writeParam(psAtoG, "propnxy", INT, &propnxy);
   writeParam(psAtoG, "propdxy", FLOAT, &propdxy);
   writeParam(psAtoG, "tbd_nxy", INT, &tbd_nxy);
   writeParam(psAtoG, "tbd_dxy", FLOAT, &tbd_dxy);
   writeParam(psAtoG, "control_interval", DOUBLE, &control_interval);
   writeParam(psAtoG, "trk_nxy", INT, &trk_nxy);
   writeParam(psAtoG, "trk_dxy", FLOAT, &trk_dxy);
   writeParam(psAtoG, "trk_gain", FLOAT, &trk_gain);
   writeParam(psAtoG, "bsm_timeConstant", FLOAT, &bsm_timeConstant);
   writeParam(psAtoG, "AO_gain", FLOAT, &AO_gain);
   writeParam(psAtoG, "dm_timeConstant", FLOAT, &dm_timeConstant);
   writeParam(psAtoG, "wfs_ifov", FLOAT, &wfs_ifov);
   writeParam(psAtoG, "img_on", BOOL, &img_on);
   writeParam(psAtoG, "img_nxy", INT, &img_nxy);
   writeParam(psAtoG, "img_dxy", FLOAT, &img_dxy);
   writeParam(psAtoG, "img_x", VECTOR_FLOAT, &img_x);
   writeParam(psAtoG, "img_y", VECTOR_FLOAT, &img_y);

   RecorderFile rfAtoG(NULL, "rfAtoG", ___trfname, ParamSet_stringify(psAtoG), psAtoG);
   VectorRecorder<float> rfAtoG1(NULL, "rfAtoG1", "AtoG.BSM.measuredTilts", "Vector<float>", "measured tilts (radians) (from an ideal pickoff sensor)", true, (float)0.0, 0.0);
   rfAtoG1.dr <<= rfAtoG.dr;
   rfAtoG1.i <<= AtoG.BSM.measuredTilts;

   VectorRecorder<float> rfAtoG2(NULL, "rfAtoG2", "AtoG.DM.measuredActuatorPositions", "Vector<float>", "current actuator positions", true, (float)0.0, 0.0);
   rfAtoG2.dr <<= rfAtoG.dr;
   rfAtoG2.i <<= AtoG.DM.measuredActuatorPositions;

   VectorRecorder<float> rfAtoG3(NULL, "rfAtoG3", "AtoG.Tracker.trackcommand", "Vector<float>", "BSM commands (angle space)", true, (float)0.0, 0.0);
   rfAtoG3.dr <<= rfAtoG.dr;
   rfAtoG3.i <<= AtoG.Tracker.trackcommand;

   GridRecorder<float> rfAtoG4(NULL, "rfAtoG4", "AtoG.Tracker.trkcamera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", true, (float)0.0, 0.0);
   rfAtoG4.dr <<= rfAtoG.dr;
   rfAtoG4.i <<= AtoG.Tracker.trkcamera.fpaImage;

   GridRecorder<float> rfAtoG5(NULL, "rfAtoG5", "AtoG.Tracker.imgcamera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", true, (float)0.0, 0.0);
   rfAtoG5.dr <<= rfAtoG.dr;
   rfAtoG5.i <<= AtoG.Tracker.imgcamera.fpaImage;

   GridRecorder<Complex> rfAtoG6(NULL, "rfAtoG6", "AtoG.Tracker.sfs.fld", "Grid<Complex>", "Integrated field", true, (float)0.0, 0.0);
   rfAtoG6.dr <<= rfAtoG.dr;
   rfAtoG6.i <<= AtoG.Tracker.sfs.fld;

   VectorRecorder<float> rfAtoG7(NULL, "rfAtoG7", "AtoG.WFS.wfsandrecon.HWFS.slopes", "Vector<float>", "", true, (float)0.0, 0.0);
   rfAtoG7.dr <<= rfAtoG.dr;
   rfAtoG7.i <<= AtoG.WFS.wfsandrecon.HWFS.slopes;

   VectorRecorder<float> rfAtoG8(NULL, "rfAtoG8", "AtoG.WFS.wfsandrecon.recon.commands", "Vector<float>", "Actuator commands (m)", true, (float)0.0, 0.0);
   rfAtoG8.dr <<= rfAtoG.dr;
   rfAtoG8.i <<= AtoG.WFS.wfsandrecon.recon.commands;

   GridRecorder<float> rfAtoG9(NULL, "rfAtoG9", "AtoG.Target.targetboard.integrated_intensity", "Grid<float>", "Integrated intensity", true, (float)0.0, 0.0);
   rfAtoG9.dr <<= rfAtoG.dr;
   rfAtoG9.i <<= AtoG.Target.targetboard.integrated_intensity;

   floatRecorder rfAtoG10(NULL, "rfAtoG10", "AtoG.Target.targetboardproc.xc", "float", "x centroid (m)", true, (float)0.0, 0.0);
   rfAtoG10.dr <<= rfAtoG.dr;
   rfAtoG10.i <<= AtoG.Target.targetboardproc.xc;

   floatRecorder rfAtoG11(NULL, "rfAtoG11", "AtoG.Target.targetboardproc.yc", "float", "y centroid (m)", true, (float)0.0, 0.0);
   rfAtoG11.dr <<= rfAtoG.dr;
   rfAtoG11.i <<= AtoG.Target.targetboardproc.yc;

   floatRecorder rfAtoG12(NULL, "rfAtoG12", "AtoG.Target.targetboardproc.onAxisIntensity", "float", "on axis intensity (value of image at origin)", true, (float)0.0, 0.0);
   rfAtoG12.dr <<= rfAtoG.dr;
   rfAtoG12.i <<= AtoG.Target.targetboardproc.onAxisIntensity;

   floatRecorder rfAtoG13(NULL, "rfAtoG13", "AtoG.Target.targetboardproc.maxIntensity", "float", "maximum intensity (maximum value of image)", true, (float)0.0, 0.0);
   rfAtoG13.dr <<= rfAtoG.dr;
   rfAtoG13.i <<= AtoG.Target.targetboardproc.maxIntensity;

   VectorRecorder<float> rfAtoG14(NULL, "rfAtoG14", "AtoG.Target.targetboardproc.xavg", "Vector<float>", "average slice through image in the x direction (averaged over y)", true, (float)0.0, 0.0);
   rfAtoG14.dr <<= rfAtoG.dr;
   rfAtoG14.i <<= AtoG.Target.targetboardproc.xavg;

   VectorRecorder<float> rfAtoG15(NULL, "rfAtoG15", "AtoG.Target.targetboardproc.yavg", "Vector<float>", "average slice through image in the y direction (averaged over x)", true, (float)0.0, 0.0);
   rfAtoG15.dr <<= rfAtoG.dr;
   rfAtoG15.i <<= AtoG.Target.targetboardproc.yavg;

   VectorRecorder<float> rfAtoG16(NULL, "rfAtoG16", "AtoG.Target.targetboardproc.ravg", "Vector<float>", "average radial slice through image (averaged over slice angle)", true, (float)0.0, 0.0);
   rfAtoG16.dr <<= rfAtoG.dr;
   rfAtoG16.i <<= AtoG.Target.targetboardproc.ravg;

   VectorRecorder<float> rfAtoG17(NULL, "rfAtoG17", "AtoG.Target.targetboardproc.pib", "Vector<float>", "integrated power in the bucket, as a function of bucket radius", true, (float)0.0, 0.0);
   rfAtoG17.dr <<= rfAtoG.dr;
   rfAtoG17.i <<= AtoG.Target.targetboardproc.pib;

   GridRecorder<Complex> rfAtoG18(NULL, "rfAtoG18", "AtoG.Telescope_.sfs.fld", "Grid<Complex>", "Integrated field", true, (float)0.0, 0.0);
   rfAtoG18.dr <<= rfAtoG.dr;
   rfAtoG18.i <<= AtoG.Telescope_.sfs.fld;



#ifndef NO_TEMPUS_SMF_MONITOR
   advanceTime(stopTime, ___smfWriter);
   ___smfWriter.Pausing();
#else
   advanceTime(stopTime);
#endif

   ___currentRun++;

#ifndef NO_TEMPUS_SMF_MONITOR
   TempusStatusSMFDynamic* ___smfDynamic = ___smfWriter.getDynamicPtr();
   ___smfDynamic->iRun = ___totalRuns + 1;
#endif

   delete tdm;
   return(0);
}
